snmp-if-deref.sh 1.59 KB
Newer Older
1
#!/bin/sh
Mike Hibler's avatar
Mike Hibler committed
2
#
3
# Copyright (c) 2006-2015 University of Utah and the Flux Group.
4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22
# 
# {{{EMULAB-LICENSE
# 
# This file is part of the Emulab network testbed software.
# 
# This file is free software: you can redistribute it and/or modify it
# under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, either version 3 of the License, or (at
# your option) any later version.
# 
# This file is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
# FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Affero General Public
# License for more details.
# 
# You should have received a copy of the GNU Affero General Public License
# along with this file.  If not, see <http://www.gnu.org/licenses/>.
# 
# }}}
Mike Hibler's avatar
Mike Hibler committed
23
#
24 25 26

community="public"

27 28
SNMPGET="/usr/local/bin/snmpget -v 2c -c $community -m CISCO-STACK-MIB:CISCO-PAGP-MIB -Ovq"

29 30 31 32 33 34 35 36 37 38 39 40 41
if [ $# -lt 4 ]
then
    echo "usage: $0 <address> <module> <port> <ifEntry-attribute> [trunk]"
    exit 1
fi

addr=$1
module=$2
port=$3
attr=$4
trunk=$5
    

42
index=`$SNMPGET $addr portIfIndex.$module.$port 2> /dev/null`
43 44 45 46
if [ $? -eq 0 -a "x$index" != "x" ]
then
    if [ "x$trunk" = "xtrunk" ]
    then
47
        index=`$SNMPGET $addr pagpGroupIfIndex.$index 2> /dev/null`
48 49
    fi

50
    retval=`$SNMPGET $addr ifEntry.$attr.$index 2> /dev/null`
51 52 53 54 55 56 57 58 59 60 61 62
    if [ $? -eq 0 -a "x$retval" != "x" ]
    then
	echo $retval
	exit 0
    else
	echo "Error getting ifEntry attribute value: $attr" 1>&2
	exit 1
    fi
else
    echo "Error looking up index for module: $module, port: $port" 1>&2
    exit 1
fi